package com.simonstl.gorille;

import java.util.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>This class stores a set of ranges of characters, making it easy to define rule sets separately from the vocabulary defined for the examples.</p>
*
*<p>Version 0.02 changes from char values to int values in order to support Unicode characters outside of Plane 0.</p>
*
* @version 0.02 9 January 2002
* @author Simon St.Laurent
*/

public class CharRanges {

protected ArrayList rangeList=new ArrayList();

public CharRanges(){
}

public void addRange(int _start, int _end) {
   CharRange newRange=new CharRange(_start, _end);
   rangeList.add(newRange);
}

public void addRange(int _character) {
   CharRange newRange=new CharRange(_character);
   rangeList.add(newRange);
}

public void addRange(CharRange newRange) {
   rangeList.add(newRange);
}

public boolean isInRanges(int test) {
  boolean returnVal=false;
  if (rangeList.size()>0){
   for (int i=0; i<rangeList.size(); i++) {
     CharRange testRange=(CharRange) rangeList.get(i);
     if (testRange.isInRange(test)){
       returnVal=true;
       break;
     } //end if
   }//end for
  }
   return returnVal;
}

public String toString() {
  StringBuffer returnVal=new StringBuffer();

  if (rangeList.size()>0){
   for (int i=0; i<rangeList.size(); i++) {
     CharRange testRange=(CharRange) rangeList.get(i);
     returnVal.append(testRange.toString());
     returnVal.append("\n");
   }
  }
  return returnVal.toString();
}

public void print(){
   System.out.println(this.toString());
}

public static void main (String[] args) {
  boolean result;

  CharRanges testRules=new CharRanges();
  CharRange testRange=new CharRange('B', 'E');
  testRules.addRange(testRange);
  testRange=new CharRange('H');
  testRules.addRange(testRange);
  testRange=new CharRange('X', 'b');
  testRules.addRange(testRange);
  testRules.print();

  result=testRules.isInRanges('B');
  System.out.println("B is in ranges: "+result);

  result=testRules.isInRanges('E');
  System.out.println("E is in ranges: "+result);

  result=testRules.isInRanges('G');
  System.out.println("G is in ranges: "+result);

  result=testRules.isInRanges('Z');
  System.out.println("Z is in ranges: "+result);

  result=testRules.isInRanges('b');
  System.out.println("b is in ranges: "+result);

  result=testRules.isInRanges('d');
  System.out.println("d is in ranges: "+result);

}


}