package com.simonstl.gorille;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License.

The Original Code is available at  http://simonstl.com/projects/fragment/original.

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved.

Contributor(s):
*/

/**
 *
 * DocProcReporter just prints the contents of everything that goes by.
 *
 */
public class DocProcReporter implements DocProcI {

    protected ContextI context;
    protected DocProcI listener;
    protected boolean verbose=true;

    public void setContext(ContextI context) {
        if (verbose) {System.out.println("Context set.");
            System.out.println("");}
        this.context=context;
    }

    public ContextI getContext() {
        if (verbose) {System.out.println("Context retrieved.");
            System.out.println("");  }
        return context;
    }

    public void setChainListener(DocProcI listener) {
        if (verbose) {System.out.println("Listener set.");
            System.out.println(""); }
        this.listener=listener;
    }

    public DocProcI getChainListener() {
        if (verbose) {System.out.println("Listener retrieved");
            System.out.println("");   }
        return listener;
    }

    /**
     *
     * Reports the XML declaration, if one is present.
     *
     * The StringBuffer content will contain the entire XML declaration.
     */
    public StringBuffer XMLdecl(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("XML declaration:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer DOCTYPE(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("DOCTYPE declaration:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer startElementOTag(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Start Element Open Tag:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer startElementCTag(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Start Element Close Tag:"); }
        System.out.println(content);
        return content;
    }

    public StringBuffer elementName(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Element name:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer tagSpace(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Tag Space:");}
        System.out.println("|"+content+"|");
        return content;
    }

    public StringBuffer attName(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Attribute name:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer attEquals(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Attribute equals:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer attStartQuote(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Attribute start quote:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer attEndQuote(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Attribute end quote"); }
        System.out.println(content);
        return content;
    }

    public StringBuffer endElementOTag(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("End element open tag:"); }
        System.out.println(content);
        return content;
    }

    public StringBuffer endElementETag(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("End element empty tag:");  }
        System.out.println(content);
        return content;

    }

    public StringBuffer endElementCTag(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("End element close tag:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer chars(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Characters:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer decCharRef(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Decimal character reference:"); }
        System.out.println(content);
        return content;
    }

    public StringBuffer hexCharRef(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Hexadecimal character reference:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer entRef(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Entity reference:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer commentStart(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Comment started");}
        System.out.println(content);
        return content;
    }

    public StringBuffer commentContent(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Comment content");}
        System.out.println(content);
        return content;
    }


    public StringBuffer commentEnd(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Comment end");}
        System.out.println(content);
        return content;
    }
    public StringBuffer PIStart(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Processing instruction start");}
        System.out.println(content);
        return content;
    }

    public StringBuffer PITarget(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Processing instruction target:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer PISpace(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Processing instruction space:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer PIData(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Processing instruction data:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer PIEnd(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("Processing instruction end:");}
        System.out.println(content);
        return content;
    }

    public StringBuffer CDATAStart(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("CDATA section start:"); }
        System.out.println(content);
        return content;
    }

    public StringBuffer CDATAEnd(StringBuffer content) throws GorilleException {
        if (verbose) {System.out.println("CDATA section end");  }
        System.out.println(content);
        return content;
    }

    /** A conduit for warning messages */
    public GorilleException warning (GorilleException e) throws GorilleException{
        System.out.println("Warning:");
        System.out.println(e);

        return e;
    }
    /** A conduit for error messages */

    public GorilleException error (GorilleException e) throws GorilleException {
        System.out.println("Error:");
        System.out.println(e);
        return e;
    }

    /** A conduit for fatal error messages */

    public GorilleException fatalError (GorilleException e) throws GorilleException {
        System.out.println("Fatal Error:");
        System.out.println(e);
        return e;
    }

    public void setVerbose(boolean _verbose){
        verbose=_verbose;
    }


}
